unit principal;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, Menus,
  ExtCtrls, ExtDlgs, RTTICtrls, StdCtrls, fpimage;

type

  { TForm1 }

  TForm1 = class(TForm)
    Image5: TImage;
    Label1: TLabel;
    Image1: TImage;
    Image2: TImage;
    Image3: TImage;
    Image4: TImage;
    Memo1: TMemo;
    Memo2: TMemo;
    Memo3: TMemo;
    NGCodeFuracao: TPage;
    NFuracao: TPage;
    SMVelocidade: TMenuItem;
    SMFuracao: TMenuItem;
    Panel1: TPanel;
    Panel2: TPanel;
    MainMenu1: TMainMenu;
    MImagem: TMenuItem;
    MGerber: TMenuItem;
    MAjuda: TMenuItem;
    MVetor: TMenuItem;
    SMSalvaOtimizada: TMenuItem;
    SMGeraGCode: TMenuItem;
    SMManual: TMenuItem;
    SMEixoZ: TMenuItem;
    SMSobre: TMenuItem;
    SMGeraCoordenadas: TMenuItem;
    SMSalvaVetorizada: TMenuItem;
    SMMapaFresagem: TMenuItem;
    SMVetorizar: TMenuItem;
    SMAbrir: TMenuItem;
    SMenuSalvaGCode: TMenuItem;
    SMTamanho: TMenuItem;
    SMTamanhoPlaca: TMenuItem;
    SMOtimizar: TMenuItem;
    SMTamanhoOtimizado: TMenuItem;
    Notebook1: TNotebook;
    NImagem: TPage;
    NImagemOtimizada: TPage;
    NVetorisada: TPage;
    NCoordenadas: TPage;
    NGCodeFresagem: TPage;
    NFrezagem: TPage;
    SavePictureDialog1: TSavePictureDialog;
    OpenPictureDialog1: TOpenPictureDialog;

    procedure FormShow(Sender: TObject);
    procedure SMFuracaoClick(Sender: TObject);
    procedure SMTamanhoOtimizadoClick(Sender: TObject);
    procedure SMGeraGCodeClick(Sender: TObject);
    procedure SMEixoZClick(Sender: TObject);
    procedure SMSalvaOtimizadaClick(Sender: TObject);
    procedure SMGeraCoordenadasClick(Sender: TObject);
    procedure SMAbrirClick(Sender: TObject);
    procedure SMenuSalvaGCodeClick(Sender: TObject);
    procedure SMTamanhoClick(Sender: TObject);
    procedure SMSalvaVetorizadaClick(Sender: TObject);
    procedure SMTamanhoPlacaClick(Sender: TObject);
    procedure SMOtimizarClick(Sender: TObject);
    procedure SMMapaFresagemClick(Sender: TObject);
    procedure SMSobreClick(Sender: TObject);
    procedure SMVelocidadeClick(Sender: TObject);
    procedure SMVetorizarClick(Sender: TObject);
    
  private
    { private declarations }
  public
    { public declarations }
  end; 

var
  Form1: TForm1; 
  tx   : real;
  ty   : real;
  Zp   : real;
  Zf   : real;
  vfz  : integer;
  vfxy : integer;
  vetori : boolean;

implementation

{ TForm1 }

uses
Otimi, Medi, Zin, fsobre, UVelocidade;


function VirgPonto(valor:string):string;
var
i : integer;

begin
 if valor <> '' then
 begin
  for i := 0 to length(valor) do
  begin
   if valor[i] = '.' then
   begin
    valor[i]:= ',';
   end
   else if valor[i] = ',' then
   begin
    valor[i] := '.';
   end;
  end;
 end;
 result := valor;
end;


procedure TForm1.FormShow(Sender: TObject);
begin
  ZF := 0.30;
  ZP := 3.00;
  vfxy := 150 ;
  vfz := 60 ;
  vetori := false;
  Notebook1.PageIndex := 0;
end;

procedure TForm1.SMFuracaoClick(Sender: TObject);
var
p : integer;
x : real;
xmax : real;
xmin : real;
y : real;
ymax : real;
ymin : real;
z : real;
n : Integer;
l : integer;
v : integer;
m : integer;
f : string;
foi : boolean;
arquivo : textfile;
linha : string;
GLinha : String;

begin
 if (tx = 0) or (ty = 0) then
  showmessage('Favor especificar o tamanho da placa antes!')
 else
 begin
  x := 0;
  xmax := 0;
  xmin := 0;
  y := 0;
  ymax := 0;
  ymin := 0;
  z := 0;
  l := 0;
  n := 0;
  m := 100;
  foi := false;
  Notebook1.PageIndex := 2;
  memo3.Clear;
  memo3.Append('; Arquivo de furao de PCI');
  memo3.Append('; Gerado pelo programa PCITOGCOD');
  memo3.Append('; Rubens Bernardi');
  memo3.Append('; Boa furao!');
  memo3.Append('G90');
  memo3.Append('G21');
  memo3.Append('M08');
  memo3.Append('M03');
  memo3.Append('M17');
  if FileExists('GCode.txt') then
  begin
  assignfile(arquivo,'GCode.txt');
   reset(arquivo);
   while (not EOF(arquivo)) do
   begin
    readln(arquivo,linha);
    if (copy(linha,1,1) = 'X') then
    begin
     p := pos('|',linha);
     x := strtoint((copy(linha,5,p - 6)));
     y := strtoint((copy(linha,p + 5,length(linha) - (p + 4))));
     x := (x / tx);
     y := (y / ty);
     if not foi then
     Begin
      xmax := x;
      ymax := y;
      xmin := x;
      ymin := y;
      foi := true;
     end;
     if (x > xmax) then xmax := x;
     if (y > ymax) then ymax := y;
     if (x < xmin) then xmin := x;
     if (y < ymin) then ymin := y;
    end;
    if (copy(linha,1,1) = 'Z') then
    begin
     foi := false;
     z := strtofloat((copy(linha,5,length(linha) - 4)));
     if ((xmax >= xmin) and ((xmax - xmin) < 1) and (ymax >= ymin) and ((ymax - ymin) < 1) and (z > 0)) then
     begin
      x := (xmin + ((xmax - xmin) / 2));
      y := (ymin + ((ymax - ymin) / 2));
      image3.Canvas.Pixels[round(x * tx),(image3.picture.bitmap.height - round(y * tx) - 1)] := ClBlack;
      l := l + 1;
      GLinha := 'N' + inttostr(l) + ' G01 X' + copy(floattostr(x),0,4 + pos(',',floattostr(x))) + ' Y' + copy(floattostr(y),0,3 + pos(',',floattostr(y))) + ' Z' + floattostr(z) + f;
      memo3.Append(GLinha);
     end;
    end;
   end;
   closefile(arquivo);
   showmessage(inttostr(l));
  end;
 end;
end;

procedure TForm1.SMTamanhoOtimizadoClick(Sender: TObject);
begin
  showmessage('x = ' + inttostr(image2.Picture.Bitmap.Width) + ' e y = ' + inttostr(image2.picture.Bitmap.Height));
end;


procedure TForm1.SMSalvaOtimizadaClick(Sender: TObject);
begin
  if savepicturedialog1.Execute then
 image2.Picture.SaveToFile(savepicturedialog1.FileName);
end;

procedure TForm1.SMGeraGCodeClick(Sender: TObject);
var
p : integer;
x : real;
y : real;
z : real;
n : Integer;
l : integer;
v : integer;
f : string;
arquivo : textfile;
linha : string;
GLinha : String;

begin
 if (tx = 0) or (ty = 0) then
  showmessage('Favor especificar o tamanho da placa antes!')
 else
 begin
  x := 0;
  y := 0;
  z := 0;
  l := 0;
  Notebook1.PageIndex := 2;
  memo2.Clear;
  memo2.Append('; Arquivo de frezagem de PCI');
  memo2.Append('; Gerado pelo programa PCITOGCOD');
  memo2.Append('; Rubens Bernardi');
  memo2.Append('; Boa fresagem!');
  memo2.Append('G90');
  memo2.Append('G21');
  memo2.Append('M08');
  memo2.Append('M03');
  memo2.Append('M17');
  if FileExists('GCode.txt') then
  begin
   assignfile(arquivo,'GCode.txt');
   reset(arquivo);
   while (not EOF(arquivo)) do
   begin
    readln(arquivo,linha);
    if (copy(linha,1,1) = 'Z') then
    begin
     z := strtofloat((copy(linha,5,length(linha) - 4)));
     if (z > 0) then
     begin
      Glinha := 'N' + inttostr(l) + ' G00 X' + copy(floattostr(x / tx),0,4 + pos(',',floattostr(x / tx))) + ' Y' + copy(floattostr(y / ty),0,3 + pos(',',floattostr(y / ty))) + ' Z' + floattostr(z);
      GLinha := VirgPonto(Glinha);
      memo2.Append(Glinha);
     end
     else
     begin
      f := ' F' + inttostr(vfz);
      Glinha := 'N' + inttostr(l) + ' G01 X' + copy(floattostr(x / tx),0,4 + pos(',',floattostr(x / tx))) + ' Y' + copy(floattostr(y / ty),0,3 + pos(',',floattostr(y / ty))) + ' Z' + floattostr(z) + f;
      GLinha := VirgPonto(Glinha);
      memo2.Append(Glinha);
     end
    end;
    if (copy(linha,1,1) = 'X') then
    begin
     if (z < 0) then
     begin
      f := ' F' + inttostr(vfxy);
      p := pos('|',linha);
      x := strtoint((copy(linha,5,p - 6)));
      y := strtoint((copy(linha,p + 5,length(linha) - (p + 4))));
      GLinha := 'N' + inttostr(l) + ' G01 X' + copy(floattostr(x / tx),0,4 + pos(',',floattostr(x / tx))) + ' Y' + copy(floattostr(y / ty),0,3 + pos(',',floattostr(y / ty))) + ' Z' + floattostr(z) + f;
      GLinha := VirgPonto(Glinha);
      memo2.Append(GLinha);
     end
     else
     begin
      p := pos('|',linha);
      x := strtoint((copy(linha,5,p - 6)));
      y := strtoint((copy(linha,p + 5,length(linha) - (p + 4))));
      GLinha := 'N' + inttostr(l) + ' G00 X' + copy(floattostr(x / tx),0,4 + pos(',',floattostr(x / tx))) + ' Y' + copy(floattostr(y / ty),0,3 + pos(',',floattostr(y / ty))) + ' Z' + floattostr(z);
      GLinha := VirgPonto(Glinha);
      memo2.Append(GLinha);
     end;
    end;
    l := l + 1;
   end;
   memo2.Append('M05');
   memo2.Append('M09');
   memo2.Append('M18');
   memo2.Append('M02');
   closefile(arquivo);
  end;
  Notebook1.PageIndex := 4;
 end;
end;


procedure TForm1.SMEixoZClick(Sender: TObject);
begin
 Zinfo.ShowModal;
end;

procedure TForm1.SMGeraCoordenadasClick(Sender: TObject);
var
x  : integer;
xv : integer;
xa : integer;
y  : integer;
yv : integer;
ya : integer;
yc : integer;
dl  : Boolean;
l  : boolean;
raster : boolean;
arquivo : textfile;

begin
 Notebook1.PageIndex := 2;
 memo1.Clear;
 xa := 0;
 ya := 0;
 memo1.Append('Z = 3');
 for x := 0 to image3.Picture.Bitmap.Width do
 begin
  for y := 0 to image3.picture.bitmap.height do
  begin
   yc := image3.picture.bitmap.height;
   if (Image3.Canvas.Pixels[x,y] = clgreen) then
   begin
    xv := x;
    yv := y;
    image3.Canvas.Pixels[x,y] := clred;
    memo1.Append('X = ' + inttostr(x) + ' | Y = ' + inttostr(yc - y));
    raster := true;
    memo1.Append('Z = -' + floattostr(ZF));
    xa := xv;
    ya := yv;
    l := false;
    while raster do
    begin
    raster := false;
     if (image3.Canvas.Pixels[xv + 1, yv] = clgreen) then
     begin
      xv := xv + 1;
      image3.Canvas.Pixels[xv,yv] := CLred;
      raster := true;
     end;
     if ((image3.Canvas.Pixels[xv,yv + 1] = clgreen) and not raster) then
     begin
      yv := yv + 1;
      image3.Canvas.Pixels[xv,yv] := CLred;
      raster := true;
     end;
     if ((image3.Canvas.Pixels[xv - 1,yv] = clgreen) and not raster) then
     begin
      xv := xv - 1;
      image3.Canvas.Pixels[xv,yv] := CLred;
      raster := true;
     end;
     if ((image3.Canvas.Pixels[xv,yv - 1] = clgreen) and not raster) then
     begin
      yv := yv - 1;
      image3.Canvas.Pixels[xv,yv] := CLred;
      raster := true;
     end;
     if ((image3.Canvas.Pixels[xv + 1,yv + 1] = clgreen) and not raster) then
     begin
      xv := xv + 1;
      yv := yv + 1;
      image3.Canvas.Pixels[xv,yv] := CLred;
      raster := true;
     end;
     if ((image3.Canvas.Pixels[xv + 1, yv - 1] = clgreen) and not raster) then
     begin
      xv := xv + 1;
      yv := yv - 1;
      image3.Canvas.Pixels[xv,yv] := CLred;
      raster := true;
     end;
     if ((image3.Canvas.Pixels[xv - 1, yv + 1] = clgreen) and not raster) then
     begin
      xv := xv - 1;
      yv := yv + 1;
      image3.Canvas.Pixels[xv,yv] := CLred;
      raster := true;
     end;
     if ((image3.Canvas.Pixels[xv - 1, yv - 1] = clgreen) and not raster) then
     begin
      xv := xv - 1;
      yv := yv - 1;
      image3.Canvas.Pixels[xv,yv] := CLred;
      raster := true;
     end;
     if ((xa <> xv) and (ya = yv)) and dl then
     begin
      dl := false;
      memo1.Append('X = ' + inttostr(xa) + ' | Y = ' + inttostr(yc - ya));
      memo1.Append('X = ' + inttostr(xv) + ' | Y = ' + inttostr(yc - yv));
     end;
     if ((xa = xv) and (ya <> yv)) and not dl then
     begin
      dl := true;
      memo1.Append('X = ' + inttostr(xa) + ' | Y = ' + inttostr(yc - ya));
      memo1.Append('X = ' + inttostr(xv) + ' | Y = ' + inttostr(yc - yv));
     end;
     xa := xv;
     ya := yv;
    end;
    memo1.Append('X = ' + inttostr(xv) + ' | Y = ' + inttostr(yc - yv));
    memo1.Append('Z = ' + floattostr(ZP));
    image3.update;
    Image3.Refresh;
   end;
  end;
 end;
 Image3.Update;
 Image3.Refresh;
 Notebook1.PageIndex := 2;
 memo1.Append('X = 0 | Y = 0');
  assignfile(arquivo,'GCode.txt');
 if not FileExists('GCode.txt') then
  Rewrite(arquivo)
 else
  erase(arquivo);
 rewrite(arquivo);
 write(arquivo,memo1.Lines.Text);
 closefile(arquivo);
 Notebook1.PageIndex := 3;
end;

procedure TForm1.SMAbrirClick(Sender: TObject);
begin
  Notebook1.PageIndex := 0;
 If openpicturedialog1.Execute then
  image1.Picture.LoadFromFile(openpicturedialog1.FileName);
 image1.Update;
end;

procedure TForm1.SMenuSalvaGCodeClick(Sender: TObject);
Var
arquivo : textfile;

begin
   assignfile(arquivo,'GCode.cnc');
 if not FileExists('GCode.cnc') then
  Rewrite(arquivo)
 else
  erase(arquivo);
 rewrite(arquivo);
 write(arquivo,memo2.Lines.Text);
 closefile(arquivo);
end;


procedure TForm1.SMTamanhoClick(Sender: TObject);

begin
  showmessage('x = ' + inttostr(image1.Picture.Bitmap.Width) + ' e y = ' + inttostr(image1.picture.Bitmap.Height));
end;

procedure TForm1.SMSalvaVetorizadaClick(Sender: TObject);
begin
  if savepicturedialog1.Execute then
 image3.Picture.SaveToFile(savepicturedialog1.FileName);
end;

procedure TForm1.SMTamanhoPlacaClick(Sender: TObject);
begin
  Medida.ShowModal;
end;


procedure TForm1.SMVetorizarClick(Sender: TObject);
var
Pcor : TFPColor;
v  : boolean;
p1 : boolean;
p2 : boolean;
p3 : boolean;
p4 : boolean;
p5 : boolean;
p6 : boolean;
p7 : boolean;
p8 : boolean;
x  : integer;
y  : integer;
begin
 Notebook1.PageIndex := 2;
 image3.Picture.Bitmap.Width := image2.Picture.Bitmap.Width;
 image3.Picture.Bitmap.Height := image2.Picture.Bitmap.Height;
 for x := 0 to image2.Picture.Bitmap.Width do
 begin
  for y := 0 to image2.picture.bitmap.height do
  begin
   Pcor := image2.Picture.Bitmap.Canvas.Colors[x,y];
   v := false;
   p1 := false;
   p2 := false;
   p3 := false;
   p4 := false;
   p5 := false;
   p6 := false;
   p7 := false;
   p8 := false;
   if (Pcor.red > 0) and (Pcor.green > 0) and (Pcor.blue > 0) then
   begin
    if (image2.Picture.Bitmap.Canvas.Colors[(x + 1),y].red > 0) and
       (image2.Picture.Bitmap.Canvas.Colors[(x + 1),y].green > 0) and
       (image2.Picture.Bitmap.Canvas.Colors[(x + 1),y].blue > 0) then p1 := true;
    if (image2.Picture.Bitmap.Canvas.Colors[(x - 1),y].red > 0) and
       (image2.Picture.Bitmap.Canvas.Colors[(x - 1),y].green > 0) and
       (image2.Picture.Bitmap.Canvas.Colors[(x - 1),y].blue > 0) then p2 := true;
    if (image2.Picture.Bitmap.Canvas.Colors[x,(y + 1)].red > 0) and
       (image2.Picture.Bitmap.Canvas.Colors[x,(y + 1)].green > 0) and
       (image2.Picture.Bitmap.Canvas.Colors[x,(y + 1)].blue > 0) then p3 := true;
    if (image2.Picture.Bitmap.Canvas.Colors[x,(y - 1)].red > 0) and
       (image2.Picture.Bitmap.Canvas.Colors[x,(y - 1)].green > 0) and
       (image2.Picture.Bitmap.Canvas.Colors[x,(y - 1)].blue > 0) then p4 := true;
    if (image2.Picture.Bitmap.Canvas.Colors[(x + 1),(y + 1)].red > 0) and
       (image2.Picture.Bitmap.Canvas.Colors[(x + 1),(y + 1)].green > 0) and
       (image2.Picture.Bitmap.Canvas.Colors[(x + 1),(y + 1)].blue > 0) then p5 := true;
    if (image2.Picture.Bitmap.Canvas.Colors[(x - 1),(y - 1)].red > 0) and
       (image2.Picture.Bitmap.Canvas.Colors[(x - 1),(y - 1)].green > 0) and
       (image2.Picture.Bitmap.Canvas.Colors[(x - 1),(y - 1)].blue > 0) then p6 := true;
    if (image2.Picture.Bitmap.Canvas.Colors[(x - 1),(y + 1)].red > 0) and
       (image2.Picture.Bitmap.Canvas.Colors[(x - 1),(y + 1)].green > 0) and
       (image2.Picture.Bitmap.Canvas.Colors[(x - 1),(y + 1)].blue > 0) then p7 := true;
    if (image2.Picture.Bitmap.Canvas.Colors[(x + 1),(y - 1)].red > 0) and
       (image2.Picture.Bitmap.Canvas.Colors[(x + 1),(y - 1)].green > 0) and
       (image2.Picture.Bitmap.Canvas.Colors[(x + 1),(y - 1)].blue > 0) then p8 := true;
    if (p1 and p2 and p3 and p4 and p5 and p6 and p7 and p8) then v := true;
    if not v then
    Begin
     image3.Canvas.Pixels[x,y] := CLGreen;
    end
    else
    image3.Canvas.Pixels[x,y] := CLWhite;
   end
   else
    image3.Canvas.Pixels[x,y] := CLWhite;
  end;
 end;
 if ((x > 0) and (y > 0)) then vetori := true;
end;

procedure TForm1.SMOtimizarClick(Sender: TObject);
begin
 Otimizar.ShowModal;
end;

procedure TForm1.SMMapaFresagemClick(Sender: TObject);
var
arquivo : textfile;
linha : string;
c  : boolean;
f  : boolean;
n  : integer;
P  : integer;
xi : integer;
xf : integer;
yi : integer;
yf : integer;
yt : integer;

begin
 Notebook1.PageIndex := 5;
 image4.picture.Clear;
 image4.picture.Bitmap.Width := image3.Picture.Bitmap.Width;
 image4.Picture.Bitmap.Height := image3.Picture.Bitmap.Height;
 yt := image3.picture.bitmap.height;
 c := false;
 f := false;
 if FileExists('GCode.txt') then
 begin
  assignfile(arquivo,'GCode.txt');
  reset(arquivo);
  while (not EOF(arquivo)) do
  begin
   readln(arquivo,linha);
   if (copy(linha,1,1) <> '') then
   begin
    if (copy(linha,1,1) <> 'Z') then
    begin
     for n := 0 to length(linha) do
     begin
      if (copy(linha,n,1) = '|') then p := n;
     end;
     xf := strtoint((copy(linha,5,p - 6)));
     yf := strtoint((copy(linha,p + 5,length(linha))));
     if c then
     begin
      if f then
      begin
      // Marca pontos do caminho onde a placa sera fresada
       image4.Canvas.Brush.color := clwhite;
       image4.Canvas.Pen.Color := clwhite;
       image4.Canvas.Line(xi,yt-yi,xf,yt-yf);
       image4.Update;
      end
      else
      begin
      // Marca pontos do caminho que a ferramenta anda sem fresar
       image4.Canvas.Brush.color := clwhite;
       image4.Canvas.Pen.Color := 4592;
       image4.Canvas.Line(xi,yt-yi,xf,yt-yf);
       image4.Update;
      end;
     end;
     xi := xf;
     yi := yf;
     c := true;
    end
    else
    begin
    if (strtofloat(copy(linha,4,length(linha)))) < 0 then
     f := true
    else
     f := false;
    end;
   end;
  end;
  closefile(arquivo);
 end;
end;

procedure TForm1.SMSobreClick(Sender: TObject);
begin
  inform.showmodal;
end;

procedure TForm1.SMVelocidadeClick(Sender: TObject);
begin
  frmVelocidade.showmodal;
end;


initialization
  {$I principal.lrs}

end.

